---
title: Sticky footers
slug: Web/CSS/Layout_cookbook/Sticky_footers
tags:
  - CSS
  - Guide
  - Layout
  - cookbook
  - flexbox
  - grid
  - sticky footer
---
<div>{{CSSRef}}</div>

<p class="summary">A sticky footer pattern is one where the footer of your page "sticks" to the bottom of the viewport in cases where the content is shorter than the viewport height. We'll look at a couple of techniques for creating one in this recipe.</p>

<p><img alt="A sticky footer pushed to the bottom of a box" src="https://mdn.mozillademos.org/files/16184/cookbook-footer.png" style="height: 807px; width: 1213px;"></p>

<h2 id="Requirements">Requirements</h2>

<p>The Sticky footer pattern needs to meet the following requirements:</p>

<ul>
 <li>Footer sticks to the bottom of the viewport when content is short.</li>
 <li>If the content of the page extends past the viewport bottom, the footer then sits below the content as normal.</li>
</ul>

<h2 id="The_recipe">The recipe</h2>

<p>{{EmbedGHLiveSample("css-examples/css-cookbook/sticky-footer.html", '100%', 720)}}</p>

<div class="note">
<p><a href="https://github.com/mdn/css-examples/blob/master/css-cookbook/sticky-footer--download.html">Download this example</a></p>
</div>

<div class="note">
<p><strong>Note</strong>: In this example and the following one we are using a wrapper set to <code>min-height: 100%</code> in order that our live example works. You could also achieve this for a full page by setting a {{cssxref("min-height")}} of <code>100vh</code> on the {{htmlelement("body")}} and then using it as your grid container.</p>
</div>

<h2 id="Choices_made">Choices made</h2>

<p>In the above example we achieve the sticky footer using CSS Grid Layout. The <code>.wrapper</code> has a minimum height of <code>100%</code> which means it is as tall as the container it is in. We then create a single column grid layout with three rows, one row for each part of our layout.</p>

<p>Grid auto-placement will place our items in source order and so the header goes into the first auto sized track, the main content into the <code>1fr</code> track and the footer into the final auto sized track. The <code>1fr</code> track will take up all available space and so grows to fill the gap.</p>

<h2 id="Alternate_method">Alternate method</h2>

<p>If you need compatibility with browsers that do not support Grid Layout you can also use Flexbox to create a sticky footer.</p>

<p>{{EmbedGHLiveSample("css-examples/css-cookbook/sticky-footer-flexbox.html", '100%', 720)}}</p>

<p>The flexbox example starts out in the same way, but we use <code>display:flex</code> rather than <code>display:grid</code> on the <code>.wrapper</code>; we also set <code>flex-direction</code> to <code>column</code>. Then we set our main content to <code>flex-grow: 1</code> and the other two elements to <code>flex-shrink: 0</code> — this prevents them from shrinking smaller when content fills the main area.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<h4 id="grid-template-rows">grid-template-rows</h4>

<p>{{Compat("css.properties.grid-template-rows")}}</p>

<h4 id="flex-direction">flex-direction</h4>

<p>{{Compat("css.properties.flex-direction")}}</p>

<h4 id="flex-grow">flex-grow</h4>

<p>{{Compat("css.properties.flex-grow")}}</p>

<h4 id="flex-shrink">flex-shrink</h4>

<p>{{Compat("css.properties.flex-shrink")}}</p>

<h2 id="Resources_on_MDN">Resources on MDN</h2>

<ul>
 <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Basic_Concepts_of_Grid_Layout">Basic concepts of Grid Layout</a></li>
</ul>
